xmonad-contrib-0.17.1: Community-maintained extensions for xmonad

Copyright | (c) 2007 Andrea Rossato
License | BSD-style (see xmonad/LICENSE)
Maintainer | andrea.rossato@unibz.it
Stability | unstable
Portability | unportable
Safe Haskell | Safe-Inferred
Language | Haskell2010

XMonad.Layout.SimpleDecoration

Contents

- Usage:

Description

A layout modifier for adding simple decorations to the windows of a given layout. The decorations are in the form of ion-like tabs for window titles.

Synopsis

- simpleDeco :: (Eq a, Shrinker s) => s -> Theme -> l a -> ModifiedLayout (Decoration SimpleDecoration s) l a
- data Theme = Theme {
  - activeColor :: String
  - inactiveColor :: String
  - urgentColor :: String
  - activeBorderColor :: String
  - inactiveBorderColor :: String
  - urgentBorderColor :: String
  - activeBorderWidth :: Dimension
  - inactiveBorderWidth :: Dimension
  - urgentBorderWidth :: Dimension
  - activeTextColor :: String
  - inactiveTextColor :: String
  - urgentTextColor :: String
  - fontName :: String
  - decoWidth :: Dimension
  - decoHeight :: Dimension
  - windowTitleAddons :: [(String, Align)]
  - windowTitleIcons :: [([[Bool]], Placement)]
  }
- def :: Default a => a
- newtype SimpleDecoration a = Simple Bool
- shrinkText :: DefaultShrinker
- data CustomShrink = CustomShrink
- class (Read s, Show s) => Shrinker s where
  - shrinkIt :: s -> String -> [String]

# Usage:

You can use this module with the following in your `~/.xmonad/xmonad.hs`:

    import XMonad.Layout.SimpleDecoration

Then edit your `layoutHook` by adding the SimpleDecoration decoration to your layout:

    myL = simpleDeco shrinkText def (layoutHook def)
    main = xmonad def { layoutHook = myL }

For more detailed instructions on editing the layoutHook see:

XMonad.Doc.Extending

You can also edit the default configuration options.

    mySDConfig = def { inactiveBorderColor = "red"
                     , inactiveTextColor   = "red"}

and

    myL = simpleDeco shrinkText mySDConfig (layoutHook def)

simpleDeco :: (Eq a, Shrinker s) => s -> Theme -> l a -> ModifiedLayout (Decoration SimpleDecoration s) l a #

Add simple decorations to windows of a layout.

data Theme #

A `Theme` is a record of colors, font etc., to customize a `DecorationStyle`.

For a collection of `Theme`s see XMonad.Util.Themes

Constructors

Theme |

Fields

- activeColor :: String

  Color of the active window

- inactiveColor :: String

  Color of the inactive window

- urgentColor :: String

  Color of the urgent window

- activeBorderColor :: String

  Color of the border of the active window

- inactiveBorderColor :: String

  Color of the border of the inactive window

- urgentBorderColor :: String

  Color of the border of the urgent window

- activeBorderWidth :: Dimension

  Width of the border of the active window

- inactiveBorderWidth :: Dimension

  Width of the border of the inactive window

- urgentBorderWidth :: Dimension

  Width of the border of the urgent window

- activeTextColor :: String

  Color of the text of the active window

- inactiveTextColor :: String

  Color of the text of the inactive window

- urgentTextColor :: String

  Color of the text of the urgent window

- fontName :: String

  Font name

- decoWidth :: Dimension

  Maximum width of the decorations (if supported by the `DecorationStyle`)

- decoHeight :: Dimension

  Height of the decorations

- windowTitleAddons :: [(String, Align)]

  Extra text to appear in a window's title bar. Refer to for a use XMonad.Layout.ImageButtonDecoration

- windowTitleIcons :: [([[Bool]], Placement)]

  Extra icons to appear in a window's title bar. Inner `[Bool]` is a row in a icon bitmap.

#### Instances

Instances details

Read Theme # |
Instance details Defined in XMonad.Layout.Decoration Methods readsPrec :: Int -> ReadS Theme # readList :: ReadS [Theme] # readPrec :: ReadPrec Theme readListPrec :: ReadPrec [Theme]
Show Theme # |
Instance details Defined in XMonad.Layout.Decoration Methods showsPrec :: Int -> Theme -> ShowS # show :: Theme -> String # showList :: [Theme] -> ShowS #
Default Theme # | The default xmonad `Theme`.
Instance details Defined in XMonad.Layout.Decoration Methods def :: Theme #

def :: Default a => a #

The default value for this type.

newtype SimpleDecoration a #

Constructors

Simple Bool |

#### Instances

Instances details

Eq a => DecorationStyle SimpleDecoration a # |

Instance details

Defined in XMonad.Layout.SimpleDecoration

Methods

describeDeco :: SimpleDecoration a -> String #

shrink :: SimpleDecoration a -> Rectangle -> Rectangle -> Rectangle #

decorationEventHook :: SimpleDecoration a -> DecorationState -> Event -> X () #

decorationCatchClicksHook :: SimpleDecoration a -> Window -> Int -> Int -> X Bool #

decorationWhileDraggingHook :: SimpleDecoration a -> CInt -> CInt -> (Window, Rectangle) -> Position -> Position -> X () #

decorationAfterDraggingHook :: SimpleDecoration a -> (Window, Rectangle) -> Window -> X () #

pureDecoration :: SimpleDecoration a -> Dimension -> Dimension -> Rectangle -> Stack a -> [(a, Rectangle)] -> (a, Rectangle) -> Maybe Rectangle #

decorate :: SimpleDecoration a -> Dimension -> Dimension -> Rectangle -> Stack a -> [(a, Rectangle)] -> (a, Rectangle) -> X (Maybe Rectangle) #

Read (SimpleDecoration a) # |
Instance details Defined in XMonad.Layout.SimpleDecoration Methods readsPrec :: Int -> ReadS (SimpleDecoration a) # readList :: ReadS [SimpleDecoration a] # readPrec :: ReadPrec (SimpleDecoration a) readListPrec :: ReadPrec [SimpleDecoration a]
Show (SimpleDecoration a) # |
Instance details Defined in XMonad.Layout.SimpleDecoration Methods showsPrec :: Int -> SimpleDecoration a -> ShowS # show :: SimpleDecoration a -> String # showList :: [SimpleDecoration a] -> ShowS #

shrinkText :: DefaultShrinker #

data CustomShrink #

Constructors

CustomShrink |

#### Instances

Instances details

Read CustomShrink # |
Instance details Defined in XMonad.Layout.Decoration Methods readsPrec :: Int -> ReadS CustomShrink # readList :: ReadS [CustomShrink] # readPrec :: ReadPrec CustomShrink readListPrec :: ReadPrec [CustomShrink]
Show CustomShrink # |
Instance details Defined in XMonad.Layout.Decoration Methods showsPrec :: Int -> CustomShrink -> ShowS # show :: CustomShrink -> String # showList :: [CustomShrink] -> ShowS #
Shrinker CustomShrink # |
Instance details Defined in XMonad.Config.Droundy Methods shrinkIt :: CustomShrink -> String -> [String] #

class (Read s, Show s) => Shrinker s where #

Methods

shrinkIt :: s -> String -> [String] #

#### Instances

Instances details

Shrinker CustomShrink # |
Instance details Defined in XMonad.Config.Droundy Methods shrinkIt :: CustomShrink -> String -> [String] #
Shrinker DefaultShrinker # |
Instance details Defined in XMonad.Layout.Decoration Methods shrinkIt :: DefaultShrinker -> String -> [String] #